
#include "precompiled_libcef.h"
#include "cef_scheme_capi.h"
#include "cef_logging.h"
#include "ctocpp/scheme_handler_ctocpp.h"
#include "ctocpp/scheme_handler_factory_ctocpp.h"

CEF_EXPORT int cef_register_scheme(const wchar_t* scheme_name,
																	 const wchar_t* host_name, struct _cef_scheme_handler_factory_t* factory)
{
	DCHECK(scheme_name);
	DCHECK(host_name);

	CefRefPtr<CefSchemeHandlerFactory> factoryPtr;
	std::wstring nameStr, codeStr;

	if(factory)
		factoryPtr = CefSchemeHandlerFactoryCToCpp::Wrap(factory);
	if(scheme_name)
		nameStr = scheme_name;
	if(host_name)
		codeStr = host_name;

	return CefRegisterScheme(nameStr, codeStr, factoryPtr);
}
